/***********************************************************
 * $Id$
 *
 * FancyLibs qmi wrapper
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 ************************************************************/

#ifndef FANCYQMIEXCEPTION_H_
#define FANCYQMIEXCEPTION_H_

#include <fancyexception.h>
#include <fancyqmilog.h>

extern "C" {
typedef struct _GError GError;
}

namespace Fancy {
namespace QMI {

class FANCYQMI_API QmiException : public Fancy::Exception
{
public:
    QmiException (int facility,
                  int priority,
                  const char *fmt, ...) throw()
#ifdef __GNUG__
            __attribute__((format(printf,4,5)))
#endif
;

    // fill in error meassage and call g_error_free on the
    // passed GError structure.
    QmiException (int facility,
                  int priority,
				  GError *error,
                  const char *fmt, ...) throw()
#ifdef __GNUG__
            __attribute__((format(printf,5,6)))
#endif
;

    virtual ~QmiException() throw();

protected:
	QmiException (int facility,
				  int priority ) throw();
};

}} // end namespaces

#endif
