/***********************************************************
 * $Id$
 *
 * FancyLibs qmi wrapper
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 ************************************************************/

#ifndef FANCYQMINETWORKTIMECALLBACK_H_
#define FANCYQMINETWORKTIMECALLBACK_H_

#include <fancyqmienums.h>
#include <fancyobject.h>

namespace Fancy {

class UtcTimestamp;

namespace QMI {

class QmiNetworkStatus;

class FANCYQMI_API QmiNetworkTimeCallback : virtual public Fancy::Object
{
public:
	typedef Fancy::ObjPtr<QmiNetworkTimeCallback> ptr_t;

	/**
	 * Callback invoked, when a new network time has been detected.
	 *
	 * @param timestamp The network time received.
	 * @param radioInterface The originating interface.
	 */
	virtual void onNetworkTimeChange(const Fancy::ObjPtr<Fancy::UtcTimestamp> &timestamp, RadioInterface radioInterface) = 0;

protected:

	QmiNetworkTimeCallback();
	virtual ~QmiNetworkTimeCallback();

};

}} // end namespaces

#endif
