/***********************************************************
 * $Id$
 *
 * FancyLibs qmi wrapper
 *
 * Copyright (C) 2014 ITEG IT-Engineers GmbH
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 ************************************************************/

#ifndef FANCYQMI_PROCESS_H
#define FANCYQMI_PROCESS_H

#include <fancyqmi.h>
#include <fancyobject.h>

namespace Fancy {
namespace QMI {

class QmiAsyncHandler;

/*
 * Run an external process and log the output in stdout and stderr.
 *
 * @c operation The operation reported to the async handler.
 * @c argv is the null-terminated argument array of the command to be executed.
 * @c asyncHandler The async handler, which will receive an Fancy::ObjPtr<Fancy::Integer> instance
 *                 containing the exit code of the process.
 *
 */
void FANCYQMI_API runProcess(const std::string &operation, const char *argv[], const Fancy::ObjPtr<QmiAsyncHandler> &asyncHandler);

}
}

#endif // ! FANCYQMI_PROCESS_H
