/***********************************************************
 * $Id$
 *
 * FancyLibs qmi wrapper
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 ************************************************************/

#ifndef FANCYQMISTARTNETWORKOUTPUT_H_
#define FANCYQMISTARTNETWORKOUTPUT_H_

#include <fancyqmienums.h>
#include <fancynumbers.h>
#include <fancystring.h>

namespace Fancy {

class String;

namespace QMI {

/**
 * Input for WdsClient->startNetwork()
 */
class FANCYQMI_API QmiStartNetworkOutput : virtual public Fancy::Object
{
public:
	typedef Fancy::ObjPtr<QmiStartNetworkOutput> ptr_t;

	static ptr_t newInstance();

	std::string toString() const;

	WdsCallEndReason getCallEndReason() const {
		return callEndReason;
	}

	void setCallEndReason(WdsCallEndReason callEndReason) {
		this->callEndReason = callEndReason;
	}

	unsigned getPacketDataHandle() const {
		return packetDataHandle;
	}

	void setPacketDataHandle(unsigned packetDataHandle) {
		this->packetDataHandle = packetDataHandle;
	}

	bool isResult() const {
		return result;
	}

	void setResult(bool result) {
		this->result = result;
	}

	int getVerboseCallEndReason() const {
		return verboseCallEndReason;
	}

	void setVerboseCallEndReason(int verboseCallEndReason) {
		this->verboseCallEndReason = verboseCallEndReason;
	}

	WdsVerboseCallEndReasonType getVerboseCallEndReasonType() const {
		return verboseCallEndReasonType;
	}

	void setVerboseCallEndReasonType(
			WdsVerboseCallEndReasonType verboseCallEndReasonType) {
		this->verboseCallEndReasonType = verboseCallEndReasonType;
	}

	const char *getVerboseCallEndReasonString() const;

protected:

	bool result;
	unsigned packetDataHandle;
	WdsCallEndReason callEndReason;
	WdsVerboseCallEndReasonType verboseCallEndReasonType;
	int verboseCallEndReason;

	QmiStartNetworkOutput();
	virtual ~QmiStartNetworkOutput();

private:
};

}} // end namespaces

#endif
