/***********************************************************
 * $Id$
 *
 * FancyLibs qmi wrapper
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 ************************************************************/

#ifndef FANCYQMISYNCHANDLER_H_
#define FANCYQMISYNCHANDLER_H_

#include <fancyqmiasynchandler.h>

namespace Fancy {
namespace QMI {

/**
 * A handler for receiving results of asynchronous results.
 */
class FANCYQMI_API QmiSyncHandler : virtual public QmiAsyncHandler
{

public:
	typedef Fancy::ObjPtr<QmiSyncHandler> ptr_t;

	static ptr_t newInstance(int timeoutMillis);

	virtual Fancy::ObjPtr<Fancy::Object> waitForResult() = 0;

protected:

	QmiSyncHandler();
	virtual ~QmiSyncHandler();

};

}} // end namespaces

#endif
