/***********************************************************
 * $Id$
 *
 * FancyLibs qmi wrapper
 *
 * Copyright (C) 2014 ITEG IT-Engineers GmbH
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 ************************************************************/

#ifndef FANCYQMI_TIMER_H
#define FANCYQMI_TIMER_H

#include <fancyqmi.h>
#include <fancyobject.h>

namespace Fancy {
namespace QMI {

class QmiAsyncHandler;

/*
 * Call the passed async handler once in a given amount of time.
 *
 * @c operation The operation reported to the async handler.
 * @c timeoutSeconds The number of seconds to wait.
 * @c result is the result passed to the sync handler
 * @c asyncHandler The async handler, which will receive the given result.
 *
 */
void FANCYQMI_API runTimed(const std::string &operation, int timeoutSeconds, const Fancy::ObjPtr<Fancy::Object> &result, const Fancy::ObjPtr<QmiAsyncHandler> &asyncHandler);

}
}

#endif // ! FANCYQMI_Timer_H
